module     p0_ddbar_emepg_golem95h4
   use precision_golem, only: ki_gol => ki
   use p0_ddbar_emepg_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p0_ddbar_emepg_config
   use p0_ddbar_emepg_groups, only: tensrec_info_group0
   use p0_ddbar_emepg_d25h4l1, only: numerator_d25 => numerator_golem95
   use p0_ddbar_emepg_d25h4l1d, only: reconstruct_d25
   use p0_ddbar_emepg_d27h4l1, only: numerator_d27 => numerator_golem95
   use p0_ddbar_emepg_d27h4l1d, only: reconstruct_d27
   use p0_ddbar_emepg_d65h4l1, only: numerator_d65 => numerator_golem95
   use p0_ddbar_emepg_d65h4l1d, only: reconstruct_d65
   use p0_ddbar_emepg_d67h4l1, only: numerator_d67 => numerator_golem95
   use p0_ddbar_emepg_d67h4l1d, only: reconstruct_d67
   use p0_ddbar_emepg_d73h4l1, only: numerator_d73 => numerator_golem95
   use p0_ddbar_emepg_d73h4l1d, only: reconstruct_d73
   use p0_ddbar_emepg_d75h4l1, only: numerator_d75 => numerator_golem95
   use p0_ddbar_emepg_d75h4l1d, only: reconstruct_d75
   use p0_ddbar_emepg_d79h4l1, only: numerator_d79 => numerator_golem95
   use p0_ddbar_emepg_d79h4l1d, only: reconstruct_d79
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 25:
      if (tens_rec_by_derivatives) then
         call reconstruct_d25(coeffs)
      else
         call reconstruct2(numerator_d25, coeffs%coeffs_25)
      end if
   !------#] Diagram 25:
   !------#[ Diagram 27:
      if (tens_rec_by_derivatives) then
         call reconstruct_d27(coeffs)
      else
         call reconstruct2(numerator_d27, coeffs%coeffs_27)
      end if
   !------#] Diagram 27:
   !------#[ Diagram 65:
      if (tens_rec_by_derivatives) then
         call reconstruct_d65(coeffs)
      else
         call reconstruct1(numerator_d65, coeffs%coeffs_65)
      end if
   !------#] Diagram 65:
   !------#[ Diagram 67:
      if (tens_rec_by_derivatives) then
         call reconstruct_d67(coeffs)
      else
         call reconstruct1(numerator_d67, coeffs%coeffs_67)
      end if
   !------#] Diagram 67:
   !------#[ Diagram 73:
      if (tens_rec_by_derivatives) then
         call reconstruct_d73(coeffs)
      else
         call reconstruct3(numerator_d73, coeffs%coeffs_73)
      end if
   !------#] Diagram 73:
   !------#[ Diagram 75:
      if (tens_rec_by_derivatives) then
         call reconstruct_d75(coeffs)
      else
         call reconstruct2(numerator_d75, coeffs%coeffs_75)
      end if
   !------#] Diagram 75:
   !------#[ Diagram 79:
      if (tens_rec_by_derivatives) then
         call reconstruct_d79(coeffs)
      else
         call reconstruct2(numerator_d79, coeffs%coeffs_79)
      end if
   !------#] Diagram 79:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p0_ddbar_emepg_config
   use p0_ddbar_emepg_groups, only: tensrec_info_group1
   use p0_ddbar_emepg_d71h4l1, only: numerator_d71 => numerator_golem95
   use p0_ddbar_emepg_d71h4l1d, only: reconstruct_d71
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 71:
      if (tens_rec_by_derivatives) then
         call reconstruct_d71(coeffs)
      else
         call reconstruct3(numerator_d71, coeffs%coeffs_71)
      end if
   !------#] Diagram 71:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p0_ddbar_emepg_config
   use p0_ddbar_emepg_groups, only: tensrec_info_group2
   use p0_ddbar_emepg_d69h4l1, only: numerator_d69 => numerator_golem95
   use p0_ddbar_emepg_d69h4l1d, only: reconstruct_d69
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 69:
      if (tens_rec_by_derivatives) then
         call reconstruct_d69(coeffs)
      else
         call reconstruct3(numerator_d69, coeffs%coeffs_69)
      end if
   !------#] Diagram 69:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
end module p0_ddbar_emepg_golem95h4
