module     p3_uubar_emepg_d67h5l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity5/d67h5l1d.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_config, only: ki
   use p3_uubar_emepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d67
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh5
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb67n8+abb67n10*(spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift&
         &(2)-spvak5k2(3)*qshift(3)-spvak5k2(4)*qshift(4))+abb67n11*dotproduct(k&
         &5, qshift)+abb67n12*dotproduct(k2, qshift)+abb67n13*(spvak4k1(1)*qshif&
         &t(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-spvak4k1(4)*qshift(4)&
         &)+abb67n9*(spvak4k3(1)*qshift(1)-spvak4k3(2)*qshift(2)-spvak4k3(3)*qsh&
         &ift(3)-spvak4k3(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb67n12+k5(iv1)*abb67n11+spvak4k1(iv1)*abb67n13+s&
         &pvak4k3(iv1)*abb67n9+spvak5k2(iv1)*abb67n10)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d67:
   subroutine     reconstruct_d67(coeffs)
      use p3_uubar_emepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_67:
      coeffs%coeffs_67%c0 = derivative(czip)
      coeffs%coeffs_67%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_67%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_67%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_67%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_67:
   end subroutine reconstruct_d67
!---#] subroutine reconstruct_d67:
end module p3_uubar_emepg_d67h5l1d
