module     p3_uubar_emepg_d25h6l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 3_uubar_emepg/helicity6/d25h6l1.f90
   ! generator: haggies (1.1)
   use p3_uubar_emepg_config, only: ki
   use p3_uubar_emepg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p3_uubar_emepg_groups, only: &
!           & sign => diagram25_sign, shift => diagram25_shift
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh6
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d25 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t2 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d25 = (abb25n2+t1*abb25n5+t2*abb25n9+abb25n4*(Q(1)*spvak3k2(1)-Q(2)*spvak3&
      &k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb25n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q&
      &(3)*k2(3)-Q(4)*k2(4))+abb25n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4&
      &))+abb25n7*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb25n8*(Q(1)*k1(1)-&
      &Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*t3*abb25n3+t2*t3*abb25n10)
      numerator = cmplx(real(d25, ki), aimag(d25), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p3_uubar_emepg_globalsl1, only: epspow
      use p3_uubar_emepg_kinematics
      use p3_uubar_emepg_abbrevh6
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t2 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t3 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d25 = (abb25n2+t1*abb25n5+t2*abb25n9+abb25n4*(Q(1)*spvak3k2(1)-Q(2)*spvak3&
      &k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb25n6*(Q(1)*k2(1)-Q(2)*k2(2)-Q&
      &(3)*k2(3)-Q(4)*k2(4))+abb25n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4&
      &))+abb25n7*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb25n8*(Q(1)*k1(1)-&
      &Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*t3*abb25n3+t2*t3*abb25n10)

      numerator = cmplx(real(d25, ki), aimag(d25), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p3_uubar_emepg_d25h6l1
